/****************************************************************************
** Form interface generated from reading ui file 'frmmain.ui'
**
** Created: Tue May 22 11:48:19 2007
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.8   edited Jan 11 14:47 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef FRMMAIN_H
#define FRMMAIN_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qmainwindow.h>
#include <qtimer.h>
#include <kiconloader.h>
#include <kpopupmenu.h>
#include <kmsystemtray.h>
#include <kmainwindow.h>
#include <qlistview.h>
#include <qhttp.h>
#include <ktabwidget.h>
#include "playlist.h"
#include "player.h"
#include "frmtags.h"
#include "randtree.h"
#include "lyrics.h"
#include "frmlyrics.h"
#include "frmaudiocddevice.h"
#include "frmrestore.h"
#include "frmlfm.h"
#include "types.h"
#include "qfile.h"
#include "frmsoundsystem.h"
#include "frmplaylist.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class KMListView;
class QMSlider;
class QGroupBox;
class QLabel;
class QPushButton;
class QButtonGroup;
class QSlider;
class KTabWidget;
class QWidget;
class QLineEdit;

class frmMain : public QMainWindow
{
    Q_OBJECT

public:
    frmMain( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~frmMain();

    QGroupBox* grpVolume;
    QLabel* pixVol;
    QMSlider* sldVol;
    QGroupBox* grpTrack;
    QPushButton* pshRemove;
    QPushButton* pshGoToCurrent;
    QPushButton* pshDown;
    QPushButton* pshUp;
    QButtonGroup* grpPlaylist;
    QPushButton* pshNewPlaylist;
    QPushButton* pshDeletePlaylist;
    QPushButton* pshClearList;
    QPushButton* pshLoop;
    QPushButton* pshRnd;
    QGroupBox* grpControl;
    QPushButton* pshLeft;
    QPushButton* pshAction;
    QPushButton* pshStop;
    QPushButton* pshRight;
    QSlider* sldPos;
    KTabWidget* tabPlaylist;
    QWidget* TabPage;
    KMListView* lstPlaylist;
    QLineEdit* txtSearch;

protected:

protected slots:
    virtual void languageChange();

private:
    QPixmap pixRndOff;
    QPixmap pixRndOn;
    bool rnd;
    CRandTree randList;
    frmTags dlgTags;
    unsigned int frame;
    QPixmap pixStop;
    short int loop;
    int playIndex;
    int playTab;
    KMSystemTray * systemTray;
    KPopupMenu * popupMenu;
    QTimer playTimer;
    CPlayer player;
    CPlaylist collection;
    QStatusBar * statBar;
    unsigned short int action;
    enum actionState{STOP, PLAY, PAUSE};
    QPixmap pixPlay;
    QPixmap pixPause;
    QPixmap pixPlayOnce;
    QPixmap pixPlayLoop;
    QString currentTrack;
    QFile confFile;
    QFile tmpFiles;
    QFile currentTrackFile;
    KPopupMenu * contextMenu;
    QString homeDir;
    QString browseDir;
    QString filePattern;
    QFile lockFile;
    bool alreadyRunning;
    CLyrics lyrics;
    frmLyrics dlgLyrics;
    QTimer searchTimer;
    QHttp * http;
    QBuffer * buffer;
    QString lyricsErrStr;
    QString audioCDDevice;
    frmAudioCDDevice dlgAudioCDDevice;
    QPixmap pixTrackLoop;
    QPopupMenu * subMenuSend;
    QPopupMenu * subMenuCopy;
    QPopupMenu * subMenuAppend;
    QPopupMenu * playlistMenu;
    int desiredVolume;
    QTimer volumeTimer;
    QTimer tmpFilesTimer;
    QBuffer * lfmBuffer;
    QString * lfmChallenge;
    QString lfmPassword;
    QString lfmUser;
    QString * lfmAddr;
    frmLfm dlgLfm;
    bool lfmOn;
    QTimer lfmTimer;
    QPopupMenu * subMenuSort;
    QPopupMenu * subMenuSortOrder;
    QPopupMenu * subMenuSortOrderAscending;
    QPopupMenu * subMenuSortOrderDescending;
    QPopupMenu * stopMenu;
    QPopupMenu * headerMenu;
    bool stopAfter;
    lfmItemList queue;
    QHttp * lfmServer;
    QHttp * lfmSubmit;
    chks headerMenuItems;
    frmSoundSystem dlgSoundSystem;
    frmPlaylist dlgPlaylist;

    QPixmap image0;
    QPixmap image1;

    void init();
    void destroy();
    void refreshPlaylist(const int & index);
    void refreshList();
    QString getTimeAsString(const int & time);
    exTags readTags(const QString & file);
    void writeTags(const QString & file, const QString & title, const QString & album, const QString & artist, const QString & year, const QString & comment, const QString & track, const QString & genre);
    QString browse(const QString & dir);
    int getRandom();
    void randMove(const int & current, const int & newCurrent);
    void onOff();
    void parse(const QString & data, bool ignoreM3u = false);
    void clearStop(bool remove = false);

private slots:
    void restore();
    void dragEnterEvent( QDragEnterEvent * event );
    void dropEvent( QDropEvent * event );
    void onNewPlaylist();
    void setTabTip();
    void onDeletePlaylist();
    void onTabChanged();
    void onClearList();
    void onAction();
    void onVolume();
    void onPlayTimer();
    void onSldPosPressed();
    void onSldPosReleased();
    void onSldPos();
    void onLeft();
    void onRight();
    void onPlaylist();
    void onUp();
    void onDown();
    void onRemove();
    void onGoToCurrent();
    void onQuitSelected();
    void onAbout();
    void onLoop();
    void editTags();
    void setTip();
    void fileDropped( QDropEvent * event, QListViewItem * after );
    void scrollVol( QWheelEvent * e );
    void onMouseButtonReleased(const QPoint & p);
    void ensureVisible();
    void onStop();
    void store();
    void addFiles();
    void addFolders();
    void saveM3u();
    void openM3u(const QString & file);
    void onSldPosValChanged();
    void random();
    void onRnd();
    void lyricsDownloaded(bool e);
    void onDelLyrics();
    void onCodecChanged(int i);
    void onKeyPressed(QKeyEvent * e);
    void onSearchTimer();
    void onSearchTextChanged();
    void showContextMenu(const QPoint & p);
    void openAudioCD();
    void copyOnPlaylist(int i);
    void sendOnPlaylist(int i);
    void copyPlaylist();
    void appendPlaylist(int i);
    void restoreVolume();
    void makeUpPlaylist(int id);
    void lastFmHandShake();
    void lastFmResolved(bool e);
    void lastFmQueue();
    void lastFmSubmited(bool e);
    void editLfm();
    void markCurrent();
    void sortPlaylist(int type);
    void onStopPressed();
    void onShowStopMenu();
    void onStopMenu(int i);
    void onShowPlaylistHeaderMenu(int i);
    void onPlaylistHeaderMenu();
    void setStatBarMsg();
    void addTmpFiles();
    void onSoundSystem();
    void onTestCanDecode(const QDragMoveEvent * e, bool & accept);
    void onReceivedDropEvent(QWidget * w, QDropEvent * e);
    void onInitiateDrag(QWidget * w);
    void onTabDblClicked(QWidget * w);
    void onSearch(bool begin = true);
    void onLyrics(bool force = false);

};

#endif // FRMMAIN_H
