/**

	Tag editor's window

**/

#include <qmessagebox.h>

#include <klocale.h>

void frmTags::init()
{
	lblTitle->setText(i18n("Title"));
	lblAlbum->setText(i18n("Album"));
	lblArtist->setText(i18n("Artist"));
	lblYear->setText(i18n("Year"));
	lblTrack->setText(i18n("Track"));
	lblGenre->setText(i18n("Genre"));
	lblComment->setText(i18n("Comment"));
	pshCancel->setText(i18n("Cancel"));
	pshNext->setText(i18n("Next"));
	pshPrevious->setText(i18n("Previous"));
	setCaption(i18n("Edit tags"));
}

void frmTags::acceptTags()
{
	ok = true;
	hide();
}

void frmTags::rejectTags()
{
	ok = false;
	hide();
}

void frmTags::nextTags()
{
	askUser();
	next = true;
	reload = true;
}

void frmTags::previousTags()
{
	askUser();
	next = false;
	reload = true;
}

void frmTags::askUser()
{
	QMessageBox msg(i18n("Question"), i18n("Do You wanna save tags to file") + "?", QMessageBox::Warning,
		QMessageBox::Yes, QMessageBox::No | QMessageBox::Default, QMessageBox::NoButton);

	if (msg.exec() == QMessageBox::Yes)
		ok = true;

	hide();
}
