#ifndef KMLISTVIEW_H
#define KMLISTVIEW_H

#include <qdragobject.h>

#include <klistview.h>

class KMListView : public KListView
{
	Q_OBJECT

	public:
		KMListView(QWidget * parent = 0, const char * name = 0);
		~KMListView();

	signals:
		void mouseButtonReleased(const QPoint &);
		void keyPressed(QKeyEvent * e);
		void rightMouseButtonClicked(const QPoint &);

	protected:
		bool acceptDrag(QDropEvent * event) const;
		//QDragObject * dragObject();
		void contentsMousePressEvent(QMouseEvent * e);
		void contentsMouseReleaseEvent(QMouseEvent * e);
		void contentsMouseMoveEvent(QMouseEvent * e);
		//void enterEvent(QEvent *);
		void keyPressEvent(QKeyEvent * e);

	private:
		bool dndPerm;
		QListViewItem * recentItem;
};

#endif
