#ifndef TYPES_H
#define TYPES_H

#include <qcheckbox.h>
#include <qstring.h>
#include <qvaluelist.h>

struct lfmItem
{
	lfmItem() {};
	lfmItem(const QString & art, const QString & tit, const QString & alb, const QString & len,
		 const QString & dat) : artist(art), title(tit), album(alb), length(len), date(dat) {};

	QString artist;
	QString title;
	QString album;
	QString length;
	QString date;
};

typedef QValueList<lfmItem> lfmItemList;
typedef QValueList<QCheckBox *> chks;
typedef QValueList<int> ints;

#endif
